//
//  SNSShareAuthorize.h
//  SNSShare
//
//  Created by 施 为 on 12-7-2.
//  Copyright (c) 2012年 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "SNSShareRequest.h"
#import "SNSShareAuthorizeWebView.h"

@class SNSShareAuthorize;

@protocol SNSShareAuthorizeDelegate <NSObject>

@required

- (void) authorize:(SNSShareAuthorize*) authorize didSucceedWithAccessToken:(NSString*)accessToken userID:(NSString*)userID expiresIn:(NSInteger) seconds;

- (void) authorize:(SNSShareAuthorize*) authorize didFailedWithError:(NSError*)error;

@end

@interface SNSShareAuthorize : NSObject<
                                SNSShareRequestDelegate,
                                SNSShareAuthorizeWebViewDelegate
>{
    NSString*               _appKey;
    NSString*               _appSecret;
    NSString*               _redirectURL;
    
    SNSShareRequest*        _request;
    
    UIViewController*       _rootViewController;
    
    id<SNSShareAuthorizeDelegate> _delegate;
}

@property(nonatomic, retain) NSString*          appKey;
@property(nonatomic, retain) NSString*          appSecret;
@property(nonatomic, retain) NSString*          redirectURL;
@property(nonatomic, retain) SNSShareRequest*   request;
@property(nonatomic, retain) UIViewController*  rootViewController;
@property(nonatomic, retain) id<SNSShareAuthorizeDelegate> delegate;

/*!
 */
- (id) initWithAppKey:(NSString*)theAppKey appSecret:(NSString*) theAppSecret;

/*!
 */
- (void) startAuthorized;
- (void) startAuthorizedUsingUserID:(NSString*)userID password:(NSString*)password;

/*!
 */

@end
