//
//  SNSShareRequest.h
//  SNSShare
//
//  Created by 施 为 on 12-7-2.
//  Copyright (c) 2012年 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>

typedef enum {
    kSNSRequestPostDataTypeNone,
    kSNSRequestPostDataTypeNormal,
    kSNSRequestPostDataTypeMutilpart
}SNSRequestPostDataType;

@class SNSShareRequest;

@protocol SNSShareRequestDelegate <NSObject>

@optional

/*!
 
 */
- (void) request:(SNSShareRequest*)request didReceiveResponse:(NSURLResponse*)response;

- (void) request:(SNSShareRequest*)request didReceiveRawData:(NSData*)data;

/*!
 @method        request:didFailWithError
 
 @discussion    notify that the request failed or suceed.that to method is prepare for
                notify the 结果 authorize and send tweet 
 */
- (void) request:(SNSShareRequest*)request didFailWithError:(NSError*)error;

- (void) request:(SNSShareRequest*)request didFinishLoadingWithResult:(id)result;

@end

@interface SNSShareRequest : NSObject
{
    NSString*               _url;
    NSString*               _httpMethod;
    NSDictionary*           _params;
    SNSRequestPostDataType  _postDataType;
    NSDictionary*           _httpHeaderFields;
    
    NSURLConnection*        _connection;
    NSMutableData*          _responseData;
    
    id<SNSShareRequestDelegate> _delegate;
}

@property (nonatomic, retain) NSString*         url;
@property (nonatomic, retain) NSString*         httpMethod;
@property (nonatomic, retain) NSDictionary*     params;
@property (nonatomic, retain) NSDictionary*     httpHeaderFields;
@property SNSRequestPostDataType                postDataType;
@property (nonatomic, retain) id<SNSShareRequestDelegate> delegate;

/*!
 */
+ (SNSShareRequest*) requestWithURL:(NSString*)url 
                         httpMethod:(NSString*)httpMethod
                             params:(NSDictionary*)params
                       postDataType:(SNSRequestPostDataType)postDataType
                   httpHeaderFields:(NSDictionary*)httpHeaderFields
                           delegate:(id<SNSShareRequestDelegate>)delegate;

/*!
 */
+ (SNSShareRequest*) requestWithAccessToken:(NSString*)accessToken 
                                        url:(NSString*)url
                                 httpMethod:(NSString*)httpMethod
                                     params:(NSDictionary*)params
                               postDataType:(SNSRequestPostDataType)postDataType
                           httpHeaderFields:(NSDictionary*)httpHeaderFields
                                   delegate:(id<SNSShareRequestDelegate>)delegate;

/*!
 */
+ (NSString*) serializeURL:(NSString*) beseURL params:(NSDictionary*) params httpMehtod:(NSString*) httpMethod;

/*!
 */
- (void) connect;

/*!
 */
- (void) disconnect;

@end
